(* Load type checking and disentangling code *)

use "dis-tgc.sml"; 

(* Print depth *)

Control.Print.printDepth := 100;

(*  Channels and values *)

val a = "a";  
val y = "y";
val z = "z";
val v=  "v";
val w=  "w"; 

(* Types *)

val e = Qualified (Un,End);
val t = Channel (e,e);
val tt = Base;
val s = Qualified (Lin,Out(t,Qualified (Lin,In(tt,e))));
val ds = Qualified (Lin,In(t,Qualified (Lin,Out(tt,e))));

(*  Contexts *)

val g = ("ct",Channel (Qualified (Lin,Out(t,e)),Qualified (Lin,In(t,e))))::(a,Channel(s,ds))::(w,tt)::[(v,t)]; 

(* Processes *)

val Q = DReplication DZero;

(*  Disentagling process *)
(*  a<v>.a(y).a(j).a<w>.(c<y>.!0 | c(z).!0) *)  
(*  Nested Session, 2-level Deadlock *)

val q1= DOutput (("ct",Void,false),DVar y,Q);

val q2= DInput (("ct",Void,false),z,Q);

val q =  DInput ((a,Void,false),"j",DOutput  ((a,Void,false),DVar (w),
                                       DParallel (q1,q2))); 
val p =  DOutput  ((a,Void,false),DVar (v), DInput ((a,Void,false),y,q));

typeCheckAndResolve(g,p);
 
