Standard ML of New Jersey v110.75 [built: Wed Nov 21 12:08:02 2012]
[opening example4-tgc.sml]
[opening dis-tgc.sml]
datatype qualifier = Lin | Un
datatype preType
  = End
  | In of sessionType * endpointType
  | Out of sessionType * endpointType
  | Start
datatype endpointType = Qualified of qualifier * preType | Void
datatype sessionType
  = Base | Channel of endpointType * endpointType | EndPoint of endpointType
type var = string
type context = (var * sessionType) list
datatype 'a dprocess
  = DContinuation
  | DIfThenElse of 'a dvalue * 'a dprocess * 'a dprocess
  | DInput of (string * endpointType * bool) * string * 'a dprocess
  | DNew of string * sessionType * 'a dprocess
  | DOutput of (string * endpointType * bool) * 'a dvalue * 'a dprocess
  | DParallel of 'a dprocess * 'a dprocess
  | DReplication of 'a dprocess
  | DZero
datatype 'a dvalue = DValue of 'a | DVar of string
exception typeFail
exception contextFail
exception contextFailL
exception sbalFail
exception notConsumed
exception checkVarFail
exception checkFail
exception projectionFail
exception decorationFail
exception swapFail
exception disentangleFail
exception inputContextWrong
exception innerDisentangleFail
val setVoid = fn : sessionType -> endpointType
val upCast = fn : sessionType * sessionType -> sessionType
val downCast = fn : sessionType -> endpointType
val dual = fn : endpointType -> endpointType
val balanced = fn : endpointType * endpointType -> bool
val sbal = fn : sessionType -> sessionType
val unRestricted = fn : sessionType -> sessionType
val compType = fn : sessionType * sessionType -> sessionType
val ioType = fn : sessionType -> sessionType
val voidType = Channel (Void,Void) : sessionType
val vType = Channel (Void,Void) : sessionType
val ioVoid = Channel (Qualified (Lin,In #),Qualified (Lin,Out #))
  : sessionType
val topStack = fn : context * var -> context
val remove = fn : context * var -> context
val isType = fn : context * var -> sessionType
val consumed = fn : context * var -> context
val finished = fn : ('a * sessionType) list -> ('a * sessionType) list
val setVoid = fn : context * var -> context
val upCastContext = fn : context * var * sessionType -> context
val upCastContextL = fn : context * var * sessionType -> context
val sbalContext = fn : ('a * sessionType) list -> ('a * sessionType) list
val projection = fn : ('a * 'b) list -> ('a * sessionType) list
val swap = fn
  : (var * sessionType) list * (var * sessionType) list * var
    -> (var * sessionType) list * (var * sessionType) list
val stringCast = fn : 'a dvalue -> string
val checkVar = fn : context * (var * sessionType) -> context
dis-tgc.sml:401.10 Warning: calling polyEqual
val dcheckVar = fn
  : (''a * sessionType) list * 'b * (''a * sessionType)
    -> (''a * sessionType) list * 'b
dis-tgc.sml:424.13 Warning: calling polyEqual
dis-tgc.sml:431.13 Warning: calling polyEqual
val fdisgt = fn
  : ''a dprocess * (string * endpointType) * string * ''a dvalue
    -> ''a dprocess * ''a dvalue
val disgt2 = fn : ''a dprocess -> ''a dprocess
val disCheck2 = fn
  : context * context * 'a dprocess -> context * context * ''b dprocess
val typeCheckAndResolve = fn
  : (var * sessionType) list * 'a dprocess
    -> (var * sessionType) list * (var * sessionType) list * ''b dprocess
val it = () : unit
[autoloading]
[library $smlnj/compiler/current.cm is stable]
[library $smlnj/compiler/x86.cm is stable]
[library $smlnj/viscomp/core.cm is stable]
[library $smlnj/viscomp/basics.cm is stable]
[library $smlnj/viscomp/elabdata.cm is stable]
[library $smlnj/viscomp/elaborate.cm is stable]
[library $SMLNJ-BASIS/basis.cm is stable]
[library $smlnj/viscomp/debugprof.cm is stable]
[library $SMLNJ-LIB/Util/smlnj-lib.cm is stable]
[library $smlnj/MLRISC/Control.cm is stable]
[library $SMLNJ-MLRISC/Control.cm is stable]
[library $controls-lib.cm(=$SMLNJ-LIB/Controls)/controls-lib.cm is stable]
[library $smlnj/smlnj-lib/controls-lib.cm is stable]
[autoloading done]
val it = () : unit
val a = "a" : string
val y = "y" : string
val v = "v" : string
val w = "w" : string
val e = Qualified (Un,End) : endpointType
val tt = Base : sessionType
val s = Qualified (Lin,Out (Base,Qualified (Un,End))) : endpointType
val ds = Qualified (Lin,In (Base,Qualified (Un,End))) : endpointType
val t =
  Channel
    (Qualified (Lin,Out (Base,Qualified (Un,End))),
     Qualified (Lin,In (Base,Qualified (Un,End)))) : sessionType
val sa =
  Qualified
    (Lin,
     Out
       (Channel
          (Qualified (Lin,Out (Base,Qualified (Un,End))),
           Qualified (Lin,In (Base,Qualified (Un,End)))),Qualified (Un,End)))
  : endpointType
val dsa =
  Qualified
    (Lin,
     In
       (Channel
          (Qualified (Lin,Out (Base,Qualified (Un,End))),
           Qualified (Lin,In (Base,Qualified (Un,End)))),Qualified (Un,End)))
  : endpointType
val g =
  [("a",
    Channel
      (Qualified
         (Lin,
          Out
            (Channel
               (Qualified (Lin,Out (Base,Qualified (Un,End))),
                Qualified (Lin,In (Base,Qualified (Un,End)))),
             Qualified (Un,End))),
       Qualified
         (Lin,
          In
            (Channel
               (Qualified (Lin,Out (Base,Qualified (Un,End))),
                Qualified (Lin,In (Base,Qualified (Un,End)))),
             Qualified (Un,End))))),("w",Base),
   ("v",
    Channel
      (Qualified (Lin,Out (Base,Qualified (Un,End))),
       Qualified (Lin,In (Base,Qualified (Un,End)))))]
  : (string * sessionType) list
val Q = DReplication DZero : 'a dprocess
val q =
  DInput
    (("y",Void,false),"z",
     DOutput (("a",Void,false),DVar "v",DReplication DZero)) : 'a dprocess
val p =
  DInput
    (("a",Void,false),"y",
     DOutput
       (("y",Void,false),DVar "w",
        DInput
          (("y",Void,false),"z",
           DOutput (("a",Void,false),DVar "v",DReplication DZero))))
  : 'a dprocess
example4-tgc.sml:41.1-41.25 Warning: type vars not generalized because of
   value restriction are instantiated to dummy types (X1,X2,...)
val it =
  ([("a",Channel (Qualified (Un,End),Qualified (Un,End))),("w",Base),
    ("v",Channel (Void,Void))],
   [("a",EndPoint (Qualified (Un,Start))),
    ("w",EndPoint (Qualified (Un,Start))),
    ("v",EndPoint (Qualified (Un,Start)))],
   DNew
     ("ray",
      Channel
        (Qualified
           (Lin,
            In
              (Channel
                 (Qualified (Lin,Out (Base,Qualified (Un,End))),
                  Qualified (Lin,In (Base,Qualified (Un,End)))),
               Qualified (Un,End))),
         Qualified
           (Lin,
            Out
              (Channel
                 (Qualified (Lin,Out (Base,Qualified (Un,End))),
                  Qualified (Lin,In (Base,Qualified (Un,End)))),
               Qualified (Un,End)))),
      DNew
        ("may",
         Channel
           (Qualified (Lin,In (Channel (Void,Void),Qualified (Un,End))),
            Qualified (Lin,Out (Channel (Void,Void),Qualified (Un,End)))),
         DParallel
           (DInput
              (("a",
                Qualified
                  (Lin,
                   In
                     (Channel
                        (Qualified (Lin,Out (Base,Qualified (Un,End))),
                         Qualified (Lin,In (Base,Qualified (Un,End)))),
                      Qualified (Un,End))),false),"z",
               DOutput (("ray",Void,false),DVar "z",DZero)),
            DParallel
              (DInput
                 (("ray",Void,false),"y",
                  DNew
                    ("ryw",
                     Channel
                       (Qualified (Lin,In (Base,Qualified (Un,End))),
                        Qualified (Lin,Out (Base,Qualified (Un,End)))),
                     DParallel
                       (DOutput
                          (("y",Qualified (Lin,Out (Base,Qualified (Un,End))),
                            false),DVar "w",
                           DInput
                             (("ryw",Void,false),"z",
                              DOutput
                                (("may",Void,false),DVar "emptychan",
                                 DReplication DZero))),
                        DInput
                          (("y",Qualified (Lin,In (Base,Qualified (Un,End))),
                            false),"z",
                           DOutput (("ryw",Void,false),DVar "z",DZero))))),
               DOutput
                 (("a",
                   Qualified
                     (Lin,
                      Out
                        (Channel
                           (Qualified (Lin,Out (Base,Qualified (Un,End))),
                            Qualified (Lin,In (Base,Qualified (Un,End)))),
                         Qualified (Un,End))),false),DVar "v",
                  DInput (("may",Void,false),"emptyVar",DZero)))))))
  : (var * sessionType) list * (var * sessionType) list * ?.X1 dprocess
- 